# -*- coding: utf-8 -*-
from setuphelpers import *
import re, requests, glob
import json


def update_package():
    # Declaring local variables
    result = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    lang = control.locale
    # Translating locale
    if "en" in lang:
        lang = "en-US"
    if "es" in lang:
        lang = "es-ES"
    arch_dict = {"x64": "linux64", "x86": "linux", "all": "linux"}

    url = requests.head(
        "https://download.mozilla.org/?product=firefox-esr-latest-ssl&os=%s&lang=%s" % (arch_dict[control.architecture], lang), proxies=proxies
    ).headers["Location"]

    filename = url.rsplit("/", 1)[1].replace("%20", " ")
    version = filename.split("-")[1].split("esr")[0]

    version_from_api = (
        json.loads(wgets("https://product-details.mozilla.org/1.0/firefox_versions.json", proxies=proxies))
        .get("FIREFOX_ESR_NEXT", "0")
        .replace("esr", "")
    )

    if Version(version_from_api) > version:
        url = url.replace(version, version_from_api)
        version = version_from_api
        filename = url.rsplit("/", 1)[1].replace("%20", "_")

    if not isfile(filename):
        print("Downloading %s from %s" % (filename, url))
        wget(url, filename, proxies=proxies)
    else:
        print(filename + " already exist")

    # updates control version from filename, increment package version.
    control.version = "%s-%s" % (re.findall(r"firefox-(.*)esr.tar.bz2", filename)[0], control.version.split("-", 1)[-1])
    control.save_control_to_wapt()

    # removes old exe
    if isfile(filename):
        exes = glob.glob("*.tar.bz2")
        for fn in exes:
            if fn != filename:
                print("Delete " + fn)
                remove_file(fn)
